<?php
// PHP code will connect to a database
// Read from a table and get result
// Formulate the result as an array to use in a convenient form
// Iterate the array
// Use PHP's function fputcsv and write the array elements
// to a CSV file
// Then push that CSV file as download
$mysqli = new mysqli("localhost", "root", "", "db_phppot_examples");
$i = 0;
$query = "SELECT id, name, type FROM tbl_php_array_to_csv";
if ($resultArray = $mysqli->query($query)) {
    while ($record = $resultArray->fetch_array()) {
        $animalArray[$i]['id'] = $record['id'];
        $animalArray[$i]['name'] = $record['name'];
        $animalArray[$i]['type'] = $record['type'];
        $i++;
    }
}
$fileOut = fopen("php://output", 'w') or die("Unable open php://output");

// Header forces the CSV file to download
header("Content-Type:application/csv");
header("Content-Disposition:attachment;filename=example-csv.csv");
// writing the first CSV record as the column labels
// Refer: https://www.php.net/manual/en/function.fputcsv.php
fputcsv($fileOut, array('id', 'name', 'type'));

// writing array elements as CSV file records one by one
foreach ($animalArray as $animal) {
    fputcsv($fileOut, $animal);
}
fclose($fileOut) or die("Unable to close php://output");
